local textButton = {}

function textButton.new(info)
   local info = info or {}
   info.type = "textButton"

   local self = Clue.newFrame(info)

   function self:setText(text) self.text = text end
   function self:setFont(font) self.font = font end
   function self:setAlign(align) self.align = align end
   function self:setLimit(limit) self.limit = limit end

   function self:getText() return self.text end
   function self:getFont() return self.font end
   function self:getAlign() return self.align end
   function self:getLimit() return self.limit end

   function self:keypressed(key)
      if key == "backspace" then self:setText(self:getText():sub(0, #self:getText()-1)) end
   end

   function self:textInput(text)
      if #self:getText() < self:getLimit() then
         self:setText(self:getText() .. text)
      end
   end

   function self:draw()
      local x, y, w, h = self:getAbsRect()
      local smoothness = self:getSmoothness()
      local bg, fg = self:getCurrentBg(), self:getCurrentFg()
      local text, font, align = self:getText(), self:getFont(), self:getAlign()

      love.graphics.setColor(bg)
      love.graphics.rectangle("fill", x, y, w, h, smoothness, smoothness)

      love.graphics.setColor(fg)
      love.graphics.setFont(self:getFont())
      love.graphics.printf(text, x, y + (h / 2) - (font:getHeight() / 2), w, align)
   end

   self:setText(info.text or "")
   self:setFont(info.font or love.graphics.getFont())
   self:setAlign(info.align or "center")
   self:setLimit(info.limit or math.huge)

   return self
end

return textButton
